library(loadeR)
library(transformeR)
library(climate4R.climdex)
library(loadeR.2nc)
library(tidyr)

rm(list=ls()) ; graphics.off() ; gc()

#Directory information
setwd("~/Documents/")
OUTPUTS <- "ETCCDI_eobs/"

#ETCCDI Indices calculation

###########################-tasmin-######################################
#Load observations
message("Loading tasmin observations...")
eobs <- loadGridData(dataset = "eobs_tasmin_spain.nc",
                      var="tasmin",
                      lonLim =c(-9.5,4.5),latLim = c(36,44)) ; gc()
num=c(1:length(eobs$xyCoords$x))

message("Done.")

indices.mon <- c("TNx","TNn","TN10p","TN90p")
indices.ann <- c("TNx","TNn","TN10p","TN90p","CSDI") #TR

indices <- list(indices.mon,indices.ann)
frequency <- c("monthly","annual")

for(i in 1:length(indices)){
index <- indices[[i]]

  for(j in 1:length(index)){

    message("Estimating ...")
    x <- lapply(num, function(num) {
    y = subsetDimension(eobs,dimension = "lon",indices = num)
    y2 = climdexGrid(index.code = index[j],tn=y,index.arg.list = list(freq=frequency[i]),
                   input.arg.list = list(base.range=c(1981,2010))) ; gc()
    return(y2)
    gc()
    }) %>% bindGrid(dimension = "lon") %>% redim(drop=T)

    grid2nc(x,NetCDFOutFile = paste(OUTPUTS,"ETCCDI_eobs_",index[j],"_",frequency[i],".nc",sep=""))
message("Done and saved.")

rm(x) ; gc()
}}
